import type { AutocompleteState, AutocompleteOptions } from '@algolia/autocomplete-core';
import React from 'react';
import type { SearchClient } from 'typesense';
import type { ConfigurationOptions as TypesenseConfigurationOptions } from 'typesense/lib/Typesense/Configuration';
import type { SearchParams as TypesenseSearchParams } from 'typesense/lib/Typesense/Documents';
import type { DocSearchHit, InternalDocSearchHit, StoredDocSearchHit } from './types';
import type { ButtonTranslations, ModalTranslations } from '.';
export declare type DocSearchTranslations = Partial<{
    button: ButtonTranslations;
    modal: ModalTranslations;
}>;
export interface DocSearchProps {
    typesenseCollectionName: string;
    typesenseServerConfig: TypesenseConfigurationOptions;
    typesenseSearchParameters: TypesenseSearchParams;
    placeholder?: string;
    transformItems?: (items: DocSearchHit[]) => DocSearchHit[];
    hitComponent?: (props: {
        hit: InternalDocSearchHit | StoredDocSearchHit;
        children: React.ReactNode;
    }) => JSX.Element;
    resultsFooterComponent?: (props: {
        state: AutocompleteState<InternalDocSearchHit>;
    }) => JSX.Element | null;
    transformSearchClient?: (searchClient: SearchClient) => SearchClient;
    disableUserPersonalization?: boolean;
    initialQuery?: string;
    navigator?: AutocompleteOptions<InternalDocSearchHit>['navigator'];
    translations?: DocSearchTranslations;
    getMissingResultsUrl?: ({ query }: {
        query: string;
    }) => string;
}
export declare function DocSearch(props: DocSearchProps): JSX.Element;
